###############################################################################
## Company      : 4JS
## Program      : fglgraph1.4gl
## Date         : 19/07/1995
## Version      : 1.10
##
## Title        : Calling of GUI functions
## 07/12/1997   : Version 2.00.1a:
##                 winquestion and winbutton accept fast input
##                 Warning! Maximum 12 buttons
##
###############################################################################

###############################################################################
##                 INITIALIZATION
###############################################################################

###############################################################################
## FUNCTION gra_resource : Activ a ressource file
## Parameters :
## filename   : file to be resourced with the extention
## Returnings :
## none
###############################################################################

FUNCTION gra_resource(envvar,filename)

  DEFINE envvar   CHAR(100)
  DEFINE filename CHAR(100)
  DEFINE cmd      CHAR(512)

  LET cmd = "catch { fglExt_source ",envvar CLIPPED," ", filename CLIPPED, "}"

  CALL fgl_uisendcommand(cmd)

END FUNCTION # gra_resource


###############################################################################
##                 DIALOGS MANAGEMENT
###############################################################################

###############################################################################
## FUNCTION gra_winquestion : Question with 1,2 or 3 possibilities of answers
## Parameters :
## p_title    : Title of the window ( only for graphic )
## p_mess     : Message to be displayed
## p_def      : Default answer : 0 for the first,
##                               1 for the second
##                               2 for the second
## p_icon     : Icon to display
## p_dang     : Dangerous answer 0 for the first, 
##                               1 for the second 
##                               2 for the third ( only for X11 graphic )
## p_item1    : First answer
## p_item2    : Second answer
## p_item3    : Third answer
## Returnings :
## ret        : answer
###############################################################################

FUNCTION gra_winquestion(p_title, p_mess,p_def,p_icon,p_dang,
                         p_item1,p_item2,p_item3)

  DEFINE p_icon   CHAR(30),
         ret      CHAR(80),
         p_title  CHAR(30),
         p_def    SMALLINT,
         p_mess   CHAR(4096),
         p_dang   SMALLINT,
         p_item1  CHAR(30),
         p_item2  CHAR(30),
         p_item3  CHAR(30),
         key      SMALLINT
  DEFINE cmd     CHAR(4096)

  LET p_mess = fgl_strtosend(p_mess)
  LET p_title = fgl_strtosend(p_title)


  LET cmd = "myMsgbox \"",p_mess CLIPPED,"\" \"", p_title CLIPPED, "\" {"

  IF p_icon IS NOT NULL AND p_icon NOT MATCHES "icon*" THEN
    LET p_icon = "icon",p_icon CLIPPED
  END IF

  IF p_def < 1 THEN
    LET p_def = 1
  END IF

  LET cmd = cmd CLIPPED," ",p_icon CLIPPED," ",
                            "defbutton",p_def using "<<<<&"
  IF NOT fgl_WtkClient() THEN
    IF p_dang >= 1  THEN
      LET cmd = cmd CLIPPED," dangbutton",p_dang CLIPPED using "<<<<&"
    END IF
    LET cmd = cmd CLIPPED, " ",p_item1 CLIPPED," ",
                           p_item2 CLIPPED," ",
                           p_item3 CLIPPED
  ELSE
    LET cmd = cmd CLIPPED, " ",p_item1 CLIPPED,
                           p_item2 CLIPPED,
                           p_item3 CLIPPED," systemmodal} {",p_item1 CLIPPED," ",
                           p_item2 CLIPPED," ",
                           p_item3 CLIPPED
  END IF
  LET cmd = cmd CLIPPED, " } ",fgl_getpid() using "<<<<<<<&"
    
  #display "win= ",cmd CLIPPED
  CALL fgl_refresh()
  CALL fgl_uisendcommand(cmd)
  sleep 0
  IF p_item1 IS NULL THEN
    LET p_item1 = "ok"
  END IF
  LET int_flag=FALSE
  LET ret=NULL
  WHILE NOT int_flag AND ret IS NULL
    LET key = fgl_getkey()
    IF key > 255 THEN
      CASE
        # press of F25 simulation
        WHEN key = 3024
          LET ret=p_item1
        WHEN key = 3025
          LET ret=p_item2
        WHEN key = 3026
          LET ret=p_item3
      END CASE
    ELSE
      IF NOT fgl_WtkClient() THEN
        LET ret=UPSHIFT(ASCII key)
        #DISPLAY "ASCII key is ",ret CLIPPED
        #LET ret=UPSHIFT(p_item1[1,1])
        #DISPLAY "First letter of item 1 is ",ret
        #LET ret=UPSHIFT(p_item2[1,1])
        #DISPLAY "First letter of item 1 is ",ret
        #LET ret=UPSHIFT(p_item3[1,1])
        #DISPLAY "First letter of item 1 is ",ret
        CASE
          WHEN UPSHIFT(ASCII key) = UPSHIFT(p_item1[1,1])
            LET ret=p_item1
          WHEN p_item2 IS NOT NULL AND UPSHIFT(ASCII key) = UPSHIFT(p_item2[1,1])
            LET ret=p_item2
          WHEN p_item3 IS NOT NULL AND UPSHIFT(ASCII key) = UPSHIFT(p_item3[1,1])
            LET ret=p_item3
        END CASE
      END IF
    END IF
  END WHILE

  LET cmd = "myMsgboxEnd ",fgl_getpid() using "<<<<<<<&"
  CALL fgl_uisendcommand(cmd)
  
  RETURN ret

END FUNCTION # gra_winquestion

###############################################################################
## FUNCTION gra_winbutton : Question dialog Window
## Parameters :
## p_title    : Title of the window ( only for graphic )
## p_mess     : Message to be displayed
## p_def      : Default answer : value of choice
## p_icon     : Icon to display
## p_dang     : Dangerous answer 0 no 
##                               1 for the first 
##                               2 for the second
##                               .
##                               .
## aItems     : array of items
## Returnings :
## ret        : answer
###############################################################################

FUNCTION gra_winbutton(p_title, p_mess,p_def,p_icon,p_dang,aItems)

  DEFINE p_icon   CHAR(30),
         ret      CHAR(80),
         p_title  CHAR(30),
         p_def    CHAR(80),
         p_mess   CHAR(4096),
         p_dang   SMALLINT,
         p_items  CHAR(4096),
         aItems   ARRAY[100] OF CHAR(100),
         nr_def   SMALLINT,
         nbItems  SMALLINT,
         i,key    SMALLINT
  DEFINE cmd     CHAR(4096)

  LET p_items = NULL
  LET nbItems=1
  LET nr_def = 1
  WHILE aItems[nbItems] IS NOT NULL
    IF p_def IS NOT NULL AND p_def = aItems[nbItems] THEN
      LET nr_def = nbItems
    END IF
    LET p_items = p_items CLIPPED," ",aItems[nbItems] CLIPPED
    LET nbItems = nbItems + 1
  END WHILE
  LET nbItems = nbItems - 1

  LET p_mess = fgl_strtosend(p_mess)
  LET p_title = fgl_strtosend(p_title)

  LET cmd = "winquestion \"",p_mess CLIPPED,"\" \"", p_title CLIPPED, "\" {"

  IF p_icon IS NOT NULL AND p_icon NOT MATCHES "icon*" THEN
    LET p_icon = "icon",p_icon CLIPPED
  END IF

  IF nr_def < 1 THEN
    LET nr_def = 1
  END IF

  LET cmd = cmd CLIPPED," ",p_icon CLIPPED," ",
                            "defbutton",nr_def using "<<<<&"

  IF p_dang >= 1  THEN
    LET cmd = cmd CLIPPED," dangbutton",p_dang CLIPPED using "<<<<&"
  END IF

  LET cmd = cmd CLIPPED, " ",p_items CLIPPED," } ",fgl_getpid() using "<<<<<<<&"
    
#  display "win= ",cmd CLIPPED
  CALL fgl_refresh()
  CALL fgl_uisendcommand(cmd)
  LET int_flag=FALSE
  LET ret=NULL
  WHILE NOT int_flag and ret IS NULL
    LET key = fgl_getkey()
    #display "key is ",key
    FOR i = 1 TO nbItems
      IF key > 255 THEN
        IF  key  = i + 3023 THEN
          #display "i is ",i
          LET ret=aItems[i]
          EXIT FOR
        END IF
      ELSE
        #LET ret=UPSHIFT(ASCII key)
        #DISPLAY "ASCII key is ",ret CLIPPED
        #LET ret=UPSHIFT(aItems[i])
        #DISPLAY "First letter of item ",i using "<<&"," is ",ret
        IF UPSHIFT(ASCII key) = UPSHIFT(aItems[i][1,1]) THEN
          LET ret=ASCII key
          #display "i is ",i
          #display "ascii key is ",ret
          LET ret=aItems[i]
          EXIT FOR
        END IF
      END IF
    END FOR
  END WHILE

  LET cmd = "myMsgboxEnd ",fgl_getpid() using "<<<<<<<&"
  CALL fgl_uisendcommand(cmd)
  RETURN ret

END FUNCTION # gra_winbutton
